/*  fortune-tcp - A RFC865 compliant client.
    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/* tcpclient.c - gets qotdd from rfc865 server */


#include "main.h"



int main(int argc, char **argv)
{
  char *host;
  int  port,ret,login;
  struct in_addr *host_addr;
  char qotd[ABS_MAX];
  int sock;
  struct sockaddr_in their_addr;

  login = parse_client_option(argc,argv,"tcp");
  host  =(char *)xmalloc(100*sizeof(char));
  host_addr = (struct in_addr *)xmalloc(sizeof(struct in_addr));

  host=get_host(host);
  port=get_port("tcp");
  if ((host_addr=atoaddr(host))==NULL){
    printf("fortune.tcp: Bad host name, exiting.\n");
    exit(1);
  }

  if ((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
    {
      perror("socket");
      exit(1);
    }

  memset((char *)&their_addr,0,sizeof(their_addr));
  their_addr.sin_family = AF_INET;      /* host byte order */
  their_addr.sin_port = port;    /* short, network byte order */
  their_addr.sin_addr = *((struct in_addr *)host_addr);

  if (connect(sock,(struct sockaddr *)&their_addr,sizeof(struct sockaddr))==-1)
    {
      perror("connect");
      exit(1);
    }

  if ((ret=recv(sock, qotd, ABS_MAX, 0)) == -1) 
    {
      perror("recv");
      exit(1);
    }

  qotd[ret] = '\0';
  if (login)
    {
      printf("\n");
    }
  printf("%s",qotd);
  if (login)
    {
      printf("\n");
    }
  close(sock);
  if (wait_flag)
    {
      sleep( (int) (0.05761*strlen(qotd)));
    }
  return 0;
}
